﻿/*#region Justin */
function VLM_GenericGetConfiguration(appID)
{
    var xml;

    xml = "<?xml version=\"1.0\"?>"+"\r\n";
    xml += "<GenericConfiguration xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">" + "\r\n";

    if (appID == COMMON_TwitchAppID)
    {
        xml += "<IsUpdated>true</IsUpdated>" + "\r\n";

        xml += "<HasLiveStreams>true</HasLiveStreams>" + "\r\n";
        xml += "<HasRecordedStreams>false</HasRecordedStreams>" + "\r\n";

        xml += "<HasFeatures>true</HasFeatures>" + "\r\n";
        xml += "<HasBrowse>true</HasBrowse>" + "\r\n";
        xml += "<HasLoginAccount>true</HasLoginAccount>" + "\r\n";

        xml += "<HasChat>true</HasChat>" + "\r\n";
        xml += "<ChatServer>irc.twitch.tv</ChatServer>" + "\r\n";

        xml += "<SendChatAdMessage>false</SendChatAdMessage>" + "\r\n";
        xml += "<ChatAdMessage>Tweetch Player: Unofficial Twitch player for Windows Phone http://www.windowsphone.com/en-us/store/app/twitch-player/ae0d973d-ce08-400f-8f40-ef6bce03813c</ChatAdMessage>" + "\r\n";
    }

    if (appID == COMMON_JustinAppID)
    {
        xml += "<IsUpdated>true</IsUpdated>" + "\r\n";

        xml += "<HasLiveStreams>true</HasLiveStreams>" + "\r\n";
        xml += "<HasRecordedStreams>false</HasRecordedStreams>" + "\r\n";

        xml += "<HasFeatures>true</HasFeatures>" + "\r\n";
        xml += "<HasBrowse>true</HasBrowse>" + "\r\n";
        xml += "<HasLoginAccount>true</HasLoginAccount>" + "\r\n";

        xml += "<HasChat>true</HasChat>" + "\r\n";
        xml += "<ChatServer>irc.justin.tv</ChatServer>" + "\r\n";

        xml += "<SendChatAdMessage>false</SendChatAdMessage>" + "\r\n";
        xml += "<ChatAdMessage></ChatAdMessage>" + "\r\n";
    }

    if (appID == COMMON_FilmonAppID)
    {
        xml += "<IsUpdated>true</IsUpdated>" + "\r\n";

        xml += "<HasLiveStreams>true</HasLiveStreams>" + "\r\n";
        xml += "<HasRecordedStreams>false</HasRecordedStreams>" + "\r\n";

        xml += "<HasFeatures>false</HasFeatures>" + "\r\n";
        xml += "<HasBrowse>true</HasBrowse>" + "\r\n";
        xml += "<HasLoginAccount>false</HasLoginAccount>" + "\r\n";

        xml += "<HasChat>false</HasChat>" + "\r\n";
        xml += "<ChatServer></ChatServer>" + "\r\n";

        xml += "<SendChatAdMessage>false</SendChatAdMessage>" + "\r\n";
        xml += "<ChatAdMessage></ChatAdMessage>" + "\r\n";
    }

    xml += "</GenericConfiguration>";

    return xml;
}
function VLM_GenericGetCategories(appID)
{
    var list;

    list = new Array();

    if (appID == COMMON_TwitchAppID)
    {
        list.push("BrowseByGame|TIT_BrowseByGame|Browse BY Game|http://www.twitch.tv/directory|Game72.png||N|I|0");
        list.push("BrowseByChannel|TIT_BrowseByChannel|Browse By Channel|http://www.twitch.tv/directory/all|Television72.png||N|I|0");
        list.push("BrowseFollowed|TIT_JCatBrowseFollowed|Followed|https://api.twitch.tv/kraken/users/$/follows/channels|Follow72.png||N|I|1");

        list.push("SearchForGame|TIT_JCatSearchGame|Search for games(live only)|https://api.twitch.tv/kraken/search/games?q=$&type=suggest|GameSearch72.png||S|I|0");
        list.push("SearchForChannel|TIT_JCatSearchChannel|Search for channels|https://api.twitch.tv/kraken/search/streams?q=$|TelevisionSearch72.png||S|I|0");
        return list;
    }

    if (appID == COMMON_JustinAppID)
    {
        // category name is case sensitive
        list.push("all|TIT_JCatAll|All|http://www.justin.tv/directory/all|JCatAll72.png||N|I|0");
        list.push("social|TIT_JCatSocial|Social|http://www.justin.tv/directory/social|JCatSocial72.png||N|I|0");
        list.push("entertainment|TIT_JCatEntertainment|Entertainment|http://www.justin.tv/directory/entertainment|JCatEntertainment72.png||N|I|0");
        list.push("gaming|TIT_JCatGaming|Gaming|http://www.justin.tv/directory/gaming|JCatGaming72.png||N|I|0");
        list.push("sports|TIT_JCatSports|Sports|http://www.justin.tv/directory/sports|JCatSports72.png||N|I|0");
        list.push("news|TIT_JCatNews|News|http://www.justin.tv/directory/news|JCatNews72.png||N|I|0");
        list.push("animals|TIT_JCatAnimals|Animals|http://www.justin.tv/directory/animals|JCatAnimals72.png||N|I|0");
        list.push("science_tech|TIT_JCatScienceTech|Science & Tech|http://www.justin.tv/directory/science_tech|JCatScienceTech72.png||N|I|0");
        list.push("educational|TIT_JCatEducational|Educational|http://www.justin.tv/directory/educational|JCatEducational72.png||N|I|0");
        list.push("other|TIT_JCatOther|Other|http://www.justin.tv/directory/other|JCatOther72.png||N|I|0");
        //list.push("search|TIT_JCatSearch|search|http://www.justin.tv/search?q=$&commit=Search|SearchCircle.png||S|M|0");

        return list;
    }

    if (appID == COMMON_FilmonAppID)
    {
        list.push("BrowseByCategory|TIT_BrowseByGame|Browse BY Game|http://www.twitch.tv/directory|Game72.png||N|I|0");
        list.push("BrowseByChannel|TIT_BrowseByChannel|Browse By Channel|http://www.twitch.tv/directory/all|Television72.png||N|I|0");
       
        return list;
    }
}

function VLM_GenericGetCategoryLinks(appID, parentItem, startIndex, userName, userPassword, extraParms)
{
    var manager;

    manager = new JSVideoLinksManager();

    if (appID == COMMON_TwitchAppID)
    {
        return GenericTwitch_GetCategoryLinks(manager, parentItem, startIndex, userName, userPassword, extraParms);
    }

    if (appID == COMMON_JustinAppID)
    {
        return GenericJustin_GetCategoryLinks(manager, parentItem, startIndex, userName, userPassword, extraParms);
    }

    if (appID == COMMON_FilmonAppID)
    {
        return GenericFilmon_GetCategoryLinks(manager, parentItem, startIndex, userName, userPassword, extraParms);
    }
}
function VLM_GenericGetPlayLinks(appID, pageUrl, channelName, userName, userPassword, extraParms)
{
    var manager;

    manager = new JSVideoLinksManager();

    if (appID == COMMON_TwitchAppID)
    {
        return GenericTwitch_GetPlayLinks(manager, pageUrl, channelName, userName, userPassword, extraParms);
    }

    if (appID == COMMON_JustinAppID)
    {
        return GenericJustin_GetPlayLinks(manager, pageUrl, userName, userPassword, extraParms);
    }

    if (appID == COMMON_FilmonAppID)
    {
        return GenericFilmon_GetPlayLinks(manager, pageUrl, userName, userPassword, extraParms);
    }
}
function VLM_GenericGetFeaturedLinks(appID, userName, userPassword, extraParms)
{
    var manager;

    manager = new JSVideoLinksManager();

    if (appID == COMMON_TwitchAppID)
    {
        return GenericTwitch_GetFeaturedLinks(manager, userName, userPassword, extraParms);
    }

    if (appID == COMMON_JustinAppID)
    {
        return GenericJustin_GetFeaturedLinks(manager, userName, userPassword, extraParms);
    }
}

/*#endregion */