﻿// do not use continue, it doesn't work
function GenericJustin_GetCategoryLinks(manager, parentItem, startIndex, userName, userPassword, extraParms)
{
    var list, url, jsonResult, parsed, cntr, name, imageUrl, viewers, isLeaf;
    var channelOwner, channelUrl, longName, category,subCategory, channelOverlayImage,videoCodec,mature;
    var keywords;
    var maxItems = 24;
    var inSearch;

    list = new Array();

    // parentitem is the category

    if (parentItem == "all")
    {
        url = "http://api.justin.tv/api/stream/list.json?&limit=" + maxItems.toString() + "&offset=" + startIndex.toString();
        inSearch = false;
    }
    else
    {
        if (manager.TextHelper.StartsWith(parentItem,"search")==false)
        {
            url = "http://api.justin.tv/api/stream/list.json?category=" + parentItem + "&limit=" + maxItems.toString() + "&offset=" + startIndex.toString();
            inSearch = false;
        }
        else
        {
            keywords = manager.TextHelper.GetSplitStringElement(parentItem, "?", 1);
            url = "http://api.justin.tv/api/stream/search/" + keywords + ".json" + "?limit=" + maxItems.toString() + "&offset=" + startIndex.toString();
            inSearch = true;
        }
    }
    
    COMMON_WriteDebugMessage(manager, "Getting content from " + url);

    manager.SetDefaultGetRequestHeaders("");
    jsonResult = manager.DownloadString(url);

    if (COMMON_IsEmptyString(jsonResult) == true)
        return list;

    parsed = JSON.parse(jsonResult);

    for (cntr = 0; cntr < parsed.length; cntr++)
    {
        category = parentItem;
        subCategory = manager.DecodeHtml(COMMON_GetString(parsed[cntr].subcategory));

        name = manager.DecodeHtml(COMMON_GetString(parsed[cntr].name));
        longName = manager.DecodeHtml(COMMON_GetString(parsed[cntr].channel.status));
        channelOwner = manager.DecodeHtml(COMMON_GetString(parsed[cntr].channel.title));

        imageUrl = COMMON_GetString(parsed[cntr].channel.screen_cap_url_medium);
        channelOverlayImage = COMMON_GetString(parsed[cntr].channel.image_url_small);

        channelUrl = COMMON_GetString(parsed[cntr].channel.channel_url);
        viewers = parsed[cntr].channel_count;

        mature = manager.DecodeHtml(COMMON_GetString(parsed[cntr].channel.mature));
        videoCodec = manager.DecodeHtml(COMMON_GetString(parsed[cntr].video_codec));

        list.push(name + "<$>" + viewers.toString() + "<$>" + imageUrl + "<$>" +
            channelOwner + "<$>" + channelUrl + "<$>" + longName + "<$>" +
            category + "<$>" + channelOverlayImage + "<$>" + "1" + "<$>" +
            subCategory + "<$>" + mature + "<$>" + videoCodec);
    }

    if (parsed.length >= maxItems)
        list.push("" + "<$>" + "1");
    else
        list.push("" + "<$>" + "0");
    
    return list;
}
function GenericJustin_GetPlayLinks(manager, pageUrl, userName, userPassword, extraParms)
{
    var swfLink,pageContent,rand,tokenLink,channelID,defaultSWF;
    var list, pos, startIndex, streamName, rtmpLink, playToken, displayName, bitRate, metaLink;

    defaultSWF = "http://www-cdn.jtvnw.net/swflibs/TwitchPlayer.swf";

    list = new Array();

    channelID = manager.GetUrlFileName(pageUrl, false);
    metaLink = "http://justin.tv/meta/" + channelID + ".xml?on_site=true";

    COMMON_WriteDebugMessage(manager, "Getting content from " + metaLink);

    manager.SetDefaultGetRequestHeaders("");
    pageContent = manager.DownloadString(metaLink);

    if (COMMON_IsEmptyString(pageContent) == true)
    {
        COMMON_WriteDebugMessage(manager, "Got empty content 1");
        return list;
    }

    swfLink = manager.TextHelper.ExtractInBetweenWithBase(pageContent, "swfobject.embedSWF", "&quot;", "&quot;");
    if (COMMON_IsEmptyString(swfLink) == true)
        swfLink = defaultSWF;

    rand = manager.GetRandom(100000, 999999);
    
    tokenLink = "http://usher.justin.tv/find/" + channelID + ".xml?type=any&p=" + rand.toString() + "&b_id=None&private_code=null&group=";

    manager.SetDefaultGetRequestHeaders(swfLink);
    pageContent = manager.DownloadString(tokenLink);

    if (COMMON_IsEmptyString(pageContent) == true)
    {
        COMMON_WriteDebugMessage(manager, "Got empty content 2");
        return list;
    }

    startIndex = 0;
    do
    {
        pos = manager.TextHelper.FindFirstIndex(pageContent, "<node>", startIndex);
        if (pos < 0)
            break;

        streamName = manager.DecodeHtml(manager.TextHelper.ExtractInBetweenWithIndex(pageContent, pos, "<play>", "</play>"));
        playToken = manager.DecodeHtml(manager.TextHelper.ExtractInBetweenWithIndex(pageContent, pos, "<token>", "</token>"));
        rtmpLink = manager.DecodeHtml(manager.TextHelper.ExtractInBetweenWithIndex(pageContent, pos, "<connect>", "</connect>"));
        bitRate = manager.DecodeHtml(manager.TextHelper.ExtractInBetweenWithIndex(pageContent, pos, "<bitrate>", "</bitrate>"));
        displayName = manager.DecodeHtml(manager.TextHelper.ExtractInBetweenWithIndex(pageContent, pos, "<display>", "</display>"));

        if (COMMON_IsEmptyString(rtmpLink) == false)
        {
            list.push(displayName + "<$>" + rtmpLink + "<$>" + streamName + "<$>" + swfLink + "<$>" + pageUrl + "<$>" + playToken + "<$>" + bitRate);
        }
        else
        {
            COMMON_WriteDebugMessage(manager, "empty rtmpLink ignored");
        }

        startIndex = pos + "<node>".length;
    }
    while (true);

    return list;
}
function GenericJustin_GetFeaturedLinks(manager, userName, userPassword, extraParms)
{
    var list, url, jsonResult, parsed, cntr, name, imageUrl, viewers, isLeaf;
    var channelOwner, channelUrl, longName, category, subCategory, channelOverlayImage, videoCodec, mature;
    var maxItems = 24;

    list = new Array();

    // parentitem is the category

    url = "http://api.justin.tv/api/stream/list.json?category=featured"+ "&limit=" + maxItems.toString() + "&offset=0";

    COMMON_WriteDebugMessage(manager, "Getting content from " + url);

    manager.SetDefaultGetRequestHeaders("");
    jsonResult = manager.DownloadString(url);

    if (COMMON_IsEmptyString(jsonResult) == true)
        return list;

    parsed = JSON.parse(jsonResult);

    for (cntr = 0; cntr < parsed.length; cntr++)
    {
        category = manager.DecodeHtml(COMMON_GetString(parsed[cntr].category));
        subCategory = manager.DecodeHtml(COMMON_GetString(parsed[cntr].subcategory));

        name = manager.DecodeHtml(COMMON_GetString(parsed[cntr].name));
        longName = manager.DecodeHtml(COMMON_GetString(parsed[cntr].channel.status));
        channelOwner = manager.DecodeHtml(COMMON_GetString(parsed[cntr].channel.title));

        imageUrl = COMMON_GetString(parsed[cntr].channel.screen_cap_url_medium);
        channelOverlayImage = COMMON_GetString(parsed[cntr].channel.image_url_small);

        channelUrl = COMMON_GetString(parsed[cntr].channel.channel_url);
        viewers = parsed[cntr].channel_count;

        mature = manager.DecodeHtml(COMMON_GetString(parsed[cntr].channel.mature));
        videoCodec = manager.DecodeHtml(COMMON_GetString(parsed[cntr].video_codec));

        list.push(name + "<$>" + viewers.toString() + "<$>" + imageUrl + "<$>" +
            channelOwner + "<$>" + channelUrl + "<$>" + longName + "<$>" +
            category + "<$>" + channelOverlayImage + "<$>" + "1" + "<$>" +
            subCategory + "<$>" + mature + "<$>" + videoCodec);
    }

    if (parsed.length >= maxItems)
        list.push("" + "<$>" + "1");
    else
        list.push("" + "<$>" + "0");


    return list;
}