﻿// do not use continue, it doesn't work
var GenericTwitch_APIVersion = 2;

function GenericTwitch_GetCategoryLinks(manager, parentItem, startIndex, userName, userPassword, extraParms)
{
    if (parentItem == "BrowseByGame")
    {
        return GenericTwitch_GetCategoryLinksForBrowseGames(manager, parentItem, startIndex, userName, userPassword, extraParms);
    }
        
    if (parentItem == "BrowseByChannel")
    {
        return GenericTwitch_GetCategoryLinksForBrowseChannels(manager, parentItem, startIndex, userName, userPassword, extraParms);
    }

    if (parentItem == "BrowseFollowed")
    {
        return GenericTwitch_GetFollowLinks(manager, startIndex, userName, userPassword, extraParms);
    }

    if (manager.TextHelper.StartsWith(parentItem, "SearchForGame"))
    {
        return GenericTwitch_GetCategoryLinksForSearchGames(manager, parentItem, startIndex, userName, userPassword, extraParms);
    }

    if (manager.TextHelper.StartsWith(parentItem, "SearchForChannel"))
    {
        return GenericTwitch_GetCategoryLinksForSearchChannels(manager, parentItem, startIndex, userName, userPassword, extraParms);
    }

    // otherwise, get channels of the game
    return GenericTwitch_GetCategoryLinksForGameChannels(manager, parentItem, startIndex, userName, userPassword, extraParms);
}
function GenericTwitch_GetCategoryLinksForBrowseGames(manager, parentItem, startIndex, userName, userPassword, extraParms)
{
    var list, url, jsonResult, parsed, cntr, name, imageUrl, viewers, isLeaf, channelOwner, channelUrl, longName, channelGame, channelOverlayImage;
    var maxItems = 24;

    list = new Array();

    url = "http://api.twitch.tv/kraken/games/top?limit=" + maxItems.toString() + "&offset=" + startIndex.toString() + "&on_site=1";
    isLeaf = "0";

    COMMON_WriteDebugMessage(manager, "Getting games from " + url);

    manager.SetDefaultGetRequestHeaders("");
    //manager.AddRequestHeader("Accept: application/vnd.twitchtv.v" + GenericTwitch_APIVersion.toString() + "+json");

    jsonResult = manager.DownloadString(url);

    if (COMMON_IsEmptyString(jsonResult) == true)
        return list;

    parsed = JSON.parse(jsonResult);

    for (cntr = 0; cntr < parsed.top.length; cntr++)
    {
        name = manager.DecodeHtml(COMMON_GetString(parsed.top[cntr].game.name));
        imageUrl = COMMON_GetString(parsed.top[cntr].game.box.medium);
        viewers = parsed.top[cntr].viewers;

        channelOwner = "";
        channelUrl = "";
        longName = "";
        channelGame = "";
        channelOverlayImage = "";

        list.push(name + "<$>" + viewers.toString() + "<$>" + imageUrl + "<$>" +
                 channelOwner + "<$>" + channelUrl + "<$>" + longName + "<$>" +
                 channelGame + "<$>" + channelOverlayImage + "<$>" + isLeaf +
                 "<$>" + "<$>" + "<$>" + "<$>" + "120" + "<$>" + "150" + "<$>" + "-1");
        //SubCat, IsMature,VideoCodec,ImageWidth,ControlHeight,IsLive
    }

    if (parsed.top.length >= maxItems)
        list.push(parsed._links.next + "<$>" + "1");
    else
        list.push("" + "<$>" + "0");

    return list;
}
function GenericTwitch_GetCategoryLinksForBrowseChannels(manager, parentItem, startIndex, userName, userPassword, extraParms)
{
    var list, url, jsonResult, parsed, cntr, name, imageUrl, viewers, isLeaf, channelOwner, channelUrl, longName, channelGame, channelOverlayImage;
    var maxItems = 24;

    var searchKeywords;

    list = new Array();

    url = "http://api.twitch.tv/kraken/streams?limit=" + maxItems.toString() + "&offset=" + startIndex.toString() + "&on_site=1";
    isLeaf = "1";

    COMMON_WriteDebugMessage(manager, "Getting channels from " + url);

    manager.SetDefaultGetRequestHeaders("");
    //manager.AddRequestHeader("Accept: application/vnd.twitchtv.v" + GenericTwitch_APIVersion.toString() + "+json");

    jsonResult = manager.DownloadString(url);

    if (COMMON_IsEmptyString(jsonResult) == true)
        return list;

    parsed = JSON.parse(jsonResult);

    for (cntr = 0; cntr < parsed.streams.length; cntr++)
    {
        name = manager.DecodeHtml(COMMON_GetString(parsed.streams[cntr].channel.name));
        imageUrl = COMMON_GetString(parsed.streams[cntr].preview.medium);
        viewers = parsed.streams[cntr].viewers;

        channelOwner = manager.DecodeHtml(COMMON_GetString(parsed.streams[cntr].channel.display_name));
        channelUrl = COMMON_GetString(parsed.streams[cntr].channel.url);
        longName = COMMON_GetString(parsed.streams[cntr].channel.status);

        channelGame = manager.DecodeHtml(COMMON_GetString(parsed.streams[cntr].game));
        channelOverlayImage = "http://static-cdn.jtvnw.net/ttv-boxart/" + manager.EncodeUrl(channelGame) + "-52x72.jpg";

        list.push(name + "<$>" + viewers.toString() + "<$>" + imageUrl + "<$>" +
                channelOwner + "<$>" + channelUrl + "<$>" + longName + "<$>" +
                channelGame + "<$>" + channelOverlayImage + "<$>" + isLeaf +
                 "<$>" + "<$>" + "<$>" + "<$>" + "170" + "<$>" + "150" + "<$>" + "-1");
        //SubCat, IsMature,VideoCodec,ImageWidth,ControlHeight,IsLive
    }

    if (parsed.streams.length >= maxItems)
        list.push(parsed._links.next + "<$>" + "1");
    else
        list.push("" + "<$>" + "0");


    return list;
}
function GenericTwitch_GetCategoryLinksForGameChannels(manager, parentItem, startIndex, userName, userPassword, extraParms)
{
    var list, url, jsonResult, parsed, cntr, name, imageUrl, viewers, isLeaf, channelOwner, channelUrl, longName, channelGame, channelOverlayImage;
    var maxItems = 24;

    list = new Array();

    //sub games (channels of the game)
    url = "http://api.twitch.tv/kraken/streams?limit=" + maxItems.toString() + "&offset=" + startIndex.toString() +
        "&game=" + manager.EncodeUrl(parentItem) + "&on_site=1";
    isLeaf = "1";

    COMMON_WriteDebugMessage(manager, "Getting channels of game from " + url);

    manager.SetDefaultGetRequestHeaders("");
    //manager.AddRequestHeader("Accept: application/vnd.twitchtv.v" + GenericTwitch_APIVersion.toString() + "+json");

    jsonResult = manager.DownloadString(url);

    if (COMMON_IsEmptyString(jsonResult) == true)
        return list;

    parsed = JSON.parse(jsonResult);

    for (cntr = 0; cntr < parsed.streams.length; cntr++)
    {
        name = manager.DecodeHtml(COMMON_GetString(parsed.streams[cntr].channel.name));
        imageUrl = COMMON_GetString(parsed.streams[cntr].preview.medium);
        viewers = parsed.streams[cntr].viewers;

        channelOwner = manager.DecodeHtml(COMMON_GetString(parsed.streams[cntr].channel.display_name));
        channelUrl = COMMON_GetString(parsed.streams[cntr].channel.url);
        longName = COMMON_GetString(parsed.streams[cntr].channel.status);

        channelGame = manager.DecodeHtml(COMMON_GetString(parsed.streams[cntr].game));
        channelOverlayImage = "http://static-cdn.jtvnw.net/ttv-boxart/" + manager.EncodeUrl(channelGame) + "-52x72.jpg";

        list.push(name + "<$>" + viewers.toString() + "<$>" + imageUrl + "<$>" +
                channelOwner + "<$>" + channelUrl + "<$>" + longName + "<$>" +
                channelGame + "<$>" + channelOverlayImage + "<$>" + isLeaf +
                "<$>" + "<$>" + "<$>" + "<$>" + "170" + "<$>" + "150" + "<$>" + "-1");
        //SubCat, IsMature,VideoCodec,ImageWidth,ControlHeight,IsLive
    }

    if (parsed.streams.length >= maxItems)
        list.push(parsed._links.next + "<$>" + "1");
    else
        list.push("" + "<$>" + "0");


    return list;
}
function GenericTwitch_GetFollowLinks(manager, startIndex, userName, userPassword, extraParms)
{
    var list, url, jsonResult, parsed, cntr, name, imageUrl, viewers, isLeaf, channelOwner, channelUrl, longName, channelGame, channelOverlayImage;
    var isLive, streamUrl, streamJsonResult, streamParsed;
    var maxItems = 24;
    var searchKeywords;

    list = new Array();

    url = "https://api.twitch.tv/kraken/users/" + userName + "/follows/channels?limit=" + maxItems.toString() + "&offset=" + startIndex.toString();
    isLeaf = "1";

    COMMON_WriteDebugMessage(manager, "Getting followed channels from " + url);

    //manager.SetDefaultGetRequestHeaders("");
    //manager.AddRequestHeader("Accept: application/vnd.twitchtv.v" + GenericTwitch_APIVersion.toString() + "+json");
    jsonResult = manager.DownloadHttpsString(url, "");

    if (COMMON_IsEmptyString(jsonResult) == true)
        return list;

    parsed = JSON.parse(jsonResult);

    for (cntr = 0; cntr < parsed.follows.length; cntr++)
    {
        name = manager.DecodeHtml(COMMON_GetString(parsed.follows[cntr].channel.name));
        imageUrl = COMMON_GetString(parsed.follows[cntr].channel.logo);
        viewers = 0;

        channelOwner = manager.DecodeHtml(COMMON_GetString(parsed.follows[cntr].channel.display_name));
        channelUrl = COMMON_GetString(parsed.follows[cntr].channel.url);
        longName = COMMON_GetString(parsed.follows[cntr].channel.status);

        channelGame = manager.DecodeHtml(COMMON_GetString(parsed.follows[cntr].game));
        channelOverlayImage = "http://static-cdn.jtvnw.net/ttv-boxart/" + manager.EncodeUrl(channelGame) + "-52x72.jpg";

        // get stream info
        isLive = "-1";
        viewers = 0;
        streamUrl = "https://api.twitch.tv/kraken/streams/" + name;
        streamJsonResult = manager.DownloadHttpsString(streamUrl, "");

        //COMMON_WriteDebugMessage(manager, "streamJsonResult " + streamJsonResult);

        if (COMMON_IsEmptyString(streamJsonResult) == false)
        {
            streamParsed = JSON.parse(streamJsonResult);
            if (streamParsed!=null && streamParsed.stream != null)
            {
                isLive = "1";
                viewers = streamParsed.stream.viewers;
            }
            else
            {
                isLive = "0";
                viewers = 0;
            }
        }
        // end of get stream info

        list.push(name + "<$>" + viewers.toString() + "<$>" + imageUrl + "<$>" +
                 channelOwner + "<$>" + channelUrl + "<$>" + longName + "<$>" +
                 channelGame + "<$>" + channelOverlayImage + "<$>" + isLeaf +
                 "<$>" + "<$>" + "<$>" + "<$>" + "170" + "<$>" + "150" + "<$>" + isLive);
        //SubCat, IsMature,VideoCodec,ImageWidth,ControlHeight,IsLive
    }

    if (parsed.follows.length >= maxItems)
        list.push(parsed._links.next + "<$>" + "1");
    else
        list.push("" + "<$>" + "0");


    return list;
}

function GenericTwitch_GetCategoryLinksForSearchGames(manager, parentItem, startIndex, userName, userPassword, extraParms)
{
    var list, url, jsonResult, parsed, cntr, name, imageUrl, viewers, isLeaf, channelOwner, channelUrl, longName, channelGame, channelOverlayImage;
    var maxItems = 24;
    var searchKeywords;

    list = new Array();

    searchKeywords = manager.TextHelper.GetSplitStringElement(parentItem, "?", 1);
    if (COMMON_IsEmptyString(searchKeywords) == true)
    {
        list.push("" + "<$>" + "0");
        return list;
    }

    url = "https://api.twitch.tv/kraken/search/games?q=" + manager.UrlEncode(searchKeywords) + "&type=suggest&live=true";
    isLeaf = "0";

    COMMON_WriteDebugMessage(manager, "searching for games " + url);

    //manager.SetDefaultGetRequestHeaders("");
    //manager.AddRequestHeader("Accept: application/vnd.twitchtv.v" + GenericTwitch_APIVersion.toString() + "+json");
    jsonResult = manager.DownloadHttpsString(url, "");

    if (COMMON_IsEmptyString(jsonResult) == true)
        return list;

    parsed = JSON.parse(jsonResult);

    for (cntr = 0; cntr < parsed.games.length; cntr++)
    {
        name = manager.DecodeHtml(COMMON_GetString(parsed.games[cntr].name));
        imageUrl = COMMON_GetString(parsed.games[cntr].box.medium);
        viewers = 0;

        channelOwner = "";
        channelUrl = "";
        longName = "";
        channelGame = "";
        channelOverlayImage = "";

        list.push(name + "<$>" + viewers.toString() + "<$>" + imageUrl + "<$>" +
            channelOwner + "<$>" + channelUrl + "<$>" + longName + "<$>" +
            channelGame + "<$>" + channelOverlayImage + "<$>" + isLeaf +
            "<$>" + "<$>" + "<$>" + "<$>" + "120" + "<$>" + "150" + "<$>" + "-1");
        //SubCat, IsMature,VideoCodec,ImageWidth,ControlHeight,IsLive
    }

    // no more games
    list.push("" + "<$>" + "0");

    return list;
}
function GenericTwitch_GetCategoryLinksForSearchChannels(manager, parentItem, startIndex, userName, userPassword, extraParms)
{
    var list, url, jsonResult, parsed, cntr, name, imageUrl, viewers, isLeaf, channelOwner, channelUrl, longName, channelGame, channelOverlayImage;
    var maxItems = 24;
    var searchKeywords;

    list = new Array();

    searchKeywords = manager.TextHelper.GetSplitStringElement(parentItem, "?", 1);
    if (COMMON_IsEmptyString(searchKeywords) == true)
    {
        list.push("" + "<$>" + "0");
        return list;
    }

    url = "https://api.twitch.tv/kraken/search/streams?q=" + manager.UrlEncode(searchKeywords) + "&limit=" + maxItems.toString() + "&offset=" + startIndex.toString();
    isLeaf = "1";

    COMMON_WriteDebugMessage(manager, "searching for channels " + url);

    //manager.SetDefaultGetRequestHeaders("");
    //manager.AddRequestHeader("Accept: application/vnd.twitchtv.v" + GenericTwitch_APIVersion.toString() + "+json");
    jsonResult = manager.DownloadHttpsString(url, "");

    if (COMMON_IsEmptyString(jsonResult) == true)
        return list;

    parsed = JSON.parse(jsonResult);

    for (cntr = 0; cntr < parsed.streams.length; cntr++)
    {
        name = manager.DecodeHtml(COMMON_GetString(parsed.streams[cntr].channel.name));
        imageUrl = COMMON_GetString(parsed.streams[cntr].preview.medium);
        viewers = parsed.streams[cntr].viewers;

        channelOwner = manager.DecodeHtml(COMMON_GetString(parsed.streams[cntr].channel.display_name));
        channelUrl = COMMON_GetString(parsed.streams[cntr].channel.url);
        longName = COMMON_GetString(parsed.streams[cntr].channel.status);

        channelGame = manager.DecodeHtml(COMMON_GetString(parsed.streams[cntr].game));
        channelOverlayImage = "http://static-cdn.jtvnw.net/ttv-boxart/" + manager.EncodeUrl(channelGame) + "-52x72.jpg";

        list.push(name + "<$>" + viewers.toString() + "<$>" + imageUrl + "<$>" +
                channelOwner + "<$>" + channelUrl + "<$>" + longName + "<$>" +
                channelGame + "<$>" + channelOverlayImage + "<$>" + isLeaf +
                "<$>" + "<$>" + "<$>" + "<$>" + "170" + "<$>" + "150" + "<$>" + "-1");
        //SubCat, IsMature,VideoCodec,ImageWidth,ControlHeight,IsLive
    }

    if (parsed.streams.length >= maxItems)
        list.push(parsed._links.next + "<$>" + "1");
    else
        list.push("" + "<$>" + "0");

    return list;
}

function GenericTwitch_GetPlayLinks(manager, pageUrl,channelName, userName, userPassword, extraParms)
{
   
    var accessTokenUrl = "https://api.twitch.tv/api/channels/$NAME$/access_token?as3=t";
    var usherUrl = "http://usher.twitch.tv/select/$NAME$.json?p=$RAND$&private_code=&type=any&allow_source=true&nauth=$TOKEN$&nauthsig=$SIG$";
    var jsonResult, parsed;
    var sig, token, rand;

    list = new Array();

    accessTokenUrl = manager.TextHelper.ReplaceText(accessTokenUrl, "$NAME$", channelName);

    COMMON_WriteDebugMessage(manager, "Getting content from " + accessTokenUrl);
    jsonResult = manager.DownloadHttpsString(accessTokenUrl, "");

    if (COMMON_IsEmptyString(jsonResult) == true)
        return list;

    parsed = JSON.parse(jsonResult);

    token = parsed.token;
    sig = parsed.sig;

    rand = manager.GetRandom(100000, 999999);

    usherUrl = manager.TextHelper.ReplaceText(usherUrl, "$NAME$", channelName);
    usherUrl = manager.TextHelper.ReplaceText(usherUrl, "$RAND$", rand.toString());
    usherUrl = manager.TextHelper.ReplaceText(usherUrl, "$TOKEN$", token);
    usherUrl = manager.TextHelper.ReplaceText(usherUrl, "$SIG$", sig);

    COMMON_WriteDebugMessage(manager, "usherUrl=" + usherUrl);

    list.push(channelName + "<$>" + "" + "<$>" + "" + "<$>" + "" + "<$>" + pageUrl + "<$>" + usherUrl + "<$>" + "");

    return list;
}

function GenericTwitch_GetFeaturedLinks(manager, userName, userPassword, extraParms)
{
    var list, url, jsonResult, parsed, cntr, name, imageUrl, viewers, isLeaf, channelOwner, channelUrl, longName, channelGame, channelOverlayImage;
    var maxItems = 10;

    list = new Array();

    url = "http://api.twitch.tv/kraken/streams/featured?limit=" + maxItems.toString() + "&on_site=1";
    isLeaf = "1";

    COMMON_WriteDebugMessage(manager, "Getting content from " + url);

    manager.SetDefaultGetRequestHeaders("");
    //manager.AddRequestHeader("Accept: application/vnd.twitchtv.v" + GenericTwitch_APIVersion.toString() + "+json");
    jsonResult = manager.DownloadString(url);

    if (COMMON_IsEmptyString(jsonResult) == true)
        return list;

    //COMMON_WriteDebugMessage(manager, "jsonResult=" + jsonResult);

    parsed = JSON.parse(jsonResult);

    for (cntr = 0; cntr < parsed.featured.length; cntr++)
    {
        name = manager.DecodeHtml(COMMON_GetString(parsed.featured[cntr].stream.channel.name));
        imageUrl = COMMON_GetString(parsed.featured[cntr].stream.preview.medium);
        viewers = parsed.featured[cntr].stream.viewers;

        channelOwner = manager.DecodeHtml(COMMON_GetString(parsed.featured[cntr].stream.channel.display_name));
        channelUrl = COMMON_GetString(parsed.featured[cntr].stream.channel.url);
        longName = COMMON_GetString(parsed.featured[cntr].stream.channel.status);

        channelGame = manager.DecodeHtml(COMMON_GetString(parsed.featured[cntr].stream.game));
        channelOverlayImage = "http://static-cdn.jtvnw.net/ttv-boxart/" + manager.EncodeUrl(channelGame) + "-52x72.jpg";

        list.push(name + "<$>" + viewers.toString() + "<$>" + imageUrl + "<$>" +
                 channelOwner + "<$>" + channelUrl + "<$>" + longName + "<$>" +
                 channelGame + "<$>" + channelOverlayImage + "<$>" + isLeaf);
    }

    if (parsed.featured.length >= maxItems)
        list.push(parsed._links.next + "<$>" + "1");
    else
        list.push("" + "<$>" + "0");

    return list;
}

